Unit FTF2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure FTF2C(var A :Array of Complex; N :Integer; IN_ :Integer;
                K :Integer; var P :Real);

implementation

procedure FTF2C(var A :Array of Complex; N :Integer; IN_ :Integer;
                K :Integer; var P :Real);
var
N1,N2,M,MM,J,JJ,I,II :Integer;
T :Real;
R,Q,RR :Complex;
const
SYS001 :Real = 3.1415926535897932384626433832795;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13;
begin
N1 := N div 2;
MM := N1 div 2;
N2 := N1+K;
J := IN_;
JJ := J;
_1:
J := J+K;
if ( J-N1 ) < 0
 then goto _2
 else if ( J-N1 ) > 0
       then goto _7
       else goto _2;
_2:
II := JJ+N1;
R := A[J-1];
A[J-1] := A[II-1];
A[II-1] := R;
J := J+K;
M := MM;
_3:
if ( JJ-M ) < 0
 then goto _5
 else if ( JJ-M ) > 0
       then goto _4
       else goto _5;
_4:
JJ := JJ-M;
M := M div 2;
goto _3;
_5:
JJ := JJ+M;
if ( JJ-J ) < 0
 then goto _1
 else if ( JJ-J ) > 0
       then goto _6
       else goto _1;
_6:
R := A[J-1];
A[J-1] := A[JJ-1];
A[JJ-1] := R;
I := J+N2;
II := JJ+N2;
R := A[I-1];
A[I-1] := A[II-1];
A[II-1] := R;
goto _1;
_7:
I := K;
T := SYS001;
if ( P ) < 0
 then goto _9
 else if ( P ) > 0
       then goto _8
       else goto _13;
_8:
T := -T;
_9:
P := -T;
_10:
Q := Cmplx(1.0,0.0);
RR := Cmplx(Cos(T),Sin(T));
T := 0.5*T;
II := I;
I := I+I;
M := IN_;
while ( M<=II ) do
 begin
  J := M;
  while ( J<=N ) do
   begin
    JJ := J+II;
    R := MulC(A[JJ-1],Q);
    A[JJ-1] := SubC(A[J-1],R);
_11:
    A[J-1] := AddC(A[J-1],R);
    inc(J,I);
   end;
_12:
  Q := MulC(Q,RR);
  inc(M,K);
 end;
if ( I-N ) < 0
 then goto _10
 else if ( I-N ) > 0
       then goto _13
       else goto _13;
_13:
end;

end.
